routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth'])->name('dashboard');

use App\Http\Controllers\PostController;
Route::resource('post', PostController::class);


require __DIR__.'/auth.php';

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;

    protected $fillable = [
        'user_id',
        'title',
        'image',
        'body'
    ];
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Post;
use Illuminate\Support\Facades\Storage;

class PostController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('post.index', [
            'posts' => Post::where('user_id', auth()->id())->get(),
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('post.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'title' => ['required'],
            'image' => ['required', 'image'],
            'body' => ['required', 'min:20']
        ]);

        Post::create([
            'user_id' => auth()->id(),
            'title' => $request->title,
            'image' => $request->file('image')->store('post/image'),
            'body' => $request->body,
        ]);

        return redirect()->route('post.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        return view('post.edit', [
            'post' => Post::find($id),
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'title' => ['required'],
            'body' => ['required', 'min:20'],
        ]);

        $post = Post::find($id);
        $image = $post->image;

        if($request->hasFile('image')) {
            Storage::delete($image);
            $image = $request->file('image')->store('post/image/');
        }

        $post->update([
            'title' => $request->title,
            'image' => $image,
            'body' => $request->body
        ]);

        return redirect()->route('post.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $post = Post::find($id);
        $image = $post->image;
        if($image != "") {
            Storage::delete($image);
        }

        Post::find($id)->delete();
        return redirect()->route('post.index');
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

app/View/Components/GuestLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class GuestLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.guest');
    }
}

resources/views/dashboard.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Dashboard') }}
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    You're logged in!
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <link rel="stylesheet" href="{{ asset('css/app.css') }}">

        <!-- Scripts -->
        <script src="{{ asset('js/app.js') }}" defer></script>
    </head>
    <body class="font-sans antialiased">
        <div class="min-h-screen bg-gray-100">
            @include('layouts.navigation')

            <!-- Page Heading -->
            <header class="bg-white shadow">
                <div class="max-w-7xl mx-auto py-6 px-4 sm:px-6 lg:px-8">
                    {{ $header }}
                </div>
            </header>

            <!-- Page Content -->
            <main>
                {{ $slot }}
            </main>
        </div>
    </body>
</html>

resources/views/layouts/guest.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <link rel="stylesheet" href="{{ asset('css/app.css') }}">

        <!-- Scripts -->
        <script src="{{ asset('js/app.js') }}" defer></script>
    </head>
    <body>
        <div class="font-sans text-gray-900 antialiased">
            {{ $slot }}
        </div>
    </body>
</html>

resources/views/layouts/navigation.blade.php
<nav x-data="{ open: false }" class="bg-white border-b border-gray-100">
    <!-- Primary Navigation Menu -->
    <div class="max-w-7xl mx-auto px-4 sm:px-6 lg:px-8">
        <div class="flex justify-between h-16">
            <div class="flex">
                <!-- Logo -->
                <div class="flex-shrink-0 flex items-center">
                    <a href="{{ route('dashboard') }}">
                        <x-application-logo class="block h-10 w-auto fill-current text-gray-600" />
                    </a>
                </div>

                <!-- Navigation Links -->
                <div class="hidden space-x-8 sm:-my-px sm:ml-10 sm:flex">
                    <x-nav-link href="{{ route('dashboard') }}" :active="request()->routeIs('dashboard')">
                        {{ __('Dashboard') }}
                    </x-nav-link>
                    <x-nav-link href="{{ route('post.index') }}" :active="request()->routeIs('post.index')">
                        {{ __('Post') }}
                    </x-nav-link>
                </div>
            </div>

            <!-- Settings Dropdown -->
            <div class="hidden sm:flex sm:items-center sm:ml-6">
                <x-dropdown align="right" width="48">
                    <x-slot name="trigger">
                        <button class="flex items-center text-sm font-medium text-gray-500 hover:text-gray-700 hover:border-gray-300 focus:outline-none focus:text-gray-700 focus:border-gray-300 transition duration-150 ease-in-out">
                            <div>{{ Auth::user()->name }}</div>

                            <div class="ml-1">
                                <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
                                    <path fill-rule="evenodd" d="M5.293 7.293a1 1 0 011.414 0L10 10.586l3.293-3.293a1 1 0 111.414 1.414l-4 4a1 1 0 01-1.414 0l-4-4a1 1 0 010-1.414z" clip-rule="evenodd" />
                                </svg>
                            </div>
                        </button>
                    </x-slot>

                    <x-slot name="content">
                        <!-- Authentication -->
                        <form method="POST" action="{{ route('logout') }}">
                            @csrf

                            <x-dropdown-link :href="route('logout')"
                                    onclick="event.preventDefault();
                                                this.closest('form').submit();">
                                {{ __('Log Out') }}
                            </x-dropdown-link>
                        </form>
                    </x-slot>
                </x-dropdown>
            </div>

            <!-- Hamburger -->
            <div class="-mr-2 flex items-center sm:hidden">
                <button @click="open = ! open" class="inline-flex items-center justify-center p-2 rounded-md text-gray-400 hover:text-gray-500 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 focus:text-gray-500 transition duration-150 ease-in-out">
                    <svg class="h-6 w-6" stroke="currentColor" fill="none" viewBox="0 0 24 24">
                        <path :class="{'hidden': open, 'inline-flex': ! open }" class="inline-flex" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M4 6h16M4 12h16M4 18h16" />
                        <path :class="{'hidden': ! open, 'inline-flex': open }" class="hidden" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M6 18L18 6M6 6l12 12" />
                    </svg>
                </button>
            </div>
        </div>
    </div>

    <!-- Responsive Navigation Menu -->
    <div :class="{'block': open, 'hidden': ! open}" class="hidden sm:hidden">
        <div class="pt-2 pb-3 space-y-1">
            <x-responsive-nav-link :href="route('dashboard')" :active="request()->routeIs('dashboard')">
                {{ __('Dashboard') }}
            </x-responsive-nav-link>
        </div>

        <!-- Responsive Settings Options -->
        <div class="pt-4 pb-1 border-t border-gray-200">
            <div class="px-4">
                <div class="font-medium text-base text-gray-800">{{ Auth::user()->name }}</div>
                <div class="font-medium text-sm text-gray-500">{{ Auth::user()->email }}</div>
            </div>

            <div class="mt-3 space-y-1">
                <!-- Authentication -->
                <form method="POST" action="{{ route('logout') }}">
                    @csrf

                    <x-responsive-nav-link :href="route('logout')"
                            onclick="event.preventDefault();
                                        this.closest('form').submit();">
                        {{ __('Log Out') }}
                    </x-responsive-nav-link>
                </form>
            </div>
        </div>
    </div>
</nav>

resources/views/post/create.blade.php
<x-app-layout>
  <x-slot name="header">
     <h2 class="font-semibold text-xl text-gray-800 leading-tight">
        {{ __('Create Post') }}
     </h2>
  </x-slot>
  <div class="py-12">
     <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div class="bg-white overflow-hidden shadow-md sm:roundedlg">
           <div class="p-6 bg-white border-b border-gray-200">
              <form action="{{ route('post.store') }}"
                 method="POST" enctype="multipart/form-data">
                 @csrf
                 <div class="mb-2">
                    <x-label for="title">Title</x-label>
                    <input type="text" name="title"
                       class="w-full form-input rounded-md
                       shadow-sm @error('title') border border-red-500 @enderror"
                       placeholder="enter blog title">
                    @error('title')
                    <span class="text-red-500">{{ $message
                    }}</span>
                    @enderror
                 </div>
                 <div class="mb-2">
                    <x-label for="title">Image</x-label>
                    <input type="file" name="image"
                       class="w-full form-input rounded-md
                       shadow-sm @error('image') border border-red-500 @enderror">
                    @error('image')
                    <span class="text-red-500">{{ $message
                    }}</span>
                    @enderror
                 </div>
                 <div class="mb-2">
                    <x-label for="body">Body</x-label>
                    <textarea name="body" id="body" rows="4"
                       class="form-input rounded-md
                       shadow-sm w-full @error('body')
                       border border-red-500
                       @enderror"
                       placeholder="enter blog
                       body"></textarea>
                    @error('body')
                    <span class="text-red-500">{{ $message
                    }}</span>
                    @enderror
                 </div>
                 <div>
                    <x-button type="submit">Save</x-button>
                 </div>
              </form>
           </div>
        </div>
     </div>
  </div>
</x-app-layout>

resources/views/post/edit.blade.php
<x-app-layout>
  <x-slot name="header">
     <h2 class="font-semibold text-xl text-gray-800 leading-tight">
        {{ __('Edit Post') }}
     </h2>
  </x-slot>
  <div class="py-12">
     <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div class="bg-white overflow-hidden shadow-md sm:roundedlg">
           <div class="p-6 bg-white border-b border-gray-200">
              <form action="{{ route('post.update', $post) }}"
                 method="POST" enctype="multipart/form-data">
                 @csrf
                 @method('PUT')
                 <div class="mb-2">
                    <x-label for="title">Title</x-label>
                    <input type="text" name="title"
                       class="w-full form-input rounded-md
                       shadow-sm @error('title') border border-red-500 @enderror"
                       placeholder="enter blog title" value="{{ old('title') ?? $post->title }}">
                    @error('title')
                    <span class="text-red-500">{{ $message }}</span>
                    @enderror
                 </div>
                 <div class="mb-2">
                    <x-label for="title">Image</x-label>
                    <img src="{{asset('storage/' . $post->image) }}" alt="" class="h-16 w-16">
                    <br/>
                    <input type="file" name="image"
                       class="w-full form-input rounded-md
                       shadow-sm @error('image') border border-red-500 @enderror">
                    @error('image')
                    <span class="text-red-500">{{ $message }}</span>
                    @enderror
                 </div>
                 <div class="mb-2">
                    <x-label for="body">Body</x-label>
                    <textarea name="body" id="body" rows="4"
                       class="form-input rounded-md
                       shadow-sm w-full @error('body')
                       border border-red-500
                       @enderror"
                       placeholder="enter blog body">{{ old('body') ?? $post->body }}</textarea>
                    @error('body')
                    <span class="text-red-500">{{ $message }}</span>
                    @enderror
                 </div>
                 <div>
                    <x-button type="submit">Save</x-button>
                 </div>
              </form>
           </div>
        </div>
     </div>
  </div>
</x-app-layout>

resources/views/post/index.blade.php
<x-app-layout>
  <x-slot name="header">
     <h2 class="font-semibold text-xl text-gray-800 leading-tight">
        {{ __('Post') }}
     </h2>
  </x-slot>
  <div class="py-12">
  <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
      <a href="{{ route('post.create') }}" class="inline-flex itemscenter px-4 py-2 bg-gray-800 border border-transparent rounded-md fontsemibold text-xs text-white uppercase tracking-widest hover:bg-gray-700
        active:bg-gray-900 focus:outline-none focus:border-gray-900
        focus:shadow-outline-gray disabled:opacity-25 transition ease-in-out
        duration-150 mb-4">Create Post</a>
      <div class="bg-white overflow-hidden shadow-md sm:roundedlg">
        <div class="flex flex-col">
           <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-
              mx-8">
              <div class="py-2 align-middle inline-block minw-full sm:px-6 lg:px-8">
                 <div class="shadow overflow-hidden border-b
                    border-gray-200 sm:rounded-lg">
                    <table class="min-w-full divide-y
                       divide-gray-200">
                       <thead class="bg-gray-50">
                          <tr>
                             <th scope="col"
                                class="px-6 py-3 text-left
                                text-xs font-medium text-gray-500 uppercase tracking-wider">
                                Title
                             </th>
                             <th scope="col"
                                class="px-6 py-3 text-left
                                text-xs font-medium text-gray-500 uppercase tracking-wider">
                                Body
                             </th>
                             <th scope="col"
                                class="px-6 py-3 text-left
                                text-xs font-medium text-gray-500 uppercase tracking-wider">
                                Image
                             </th>
                             <th scope="col" class="relative
                                px-6 py-3">
                                <span class="sronly">Edit</span>
                             </th>
                          </tr>
                       </thead>
                       <tbody class="bg-white divide-y divide-gray-200">
                          @foreach($posts as $post)
                          <tr>
                             <td class="px-6 py-4
                                whitespace-nowrap">
                                <div class="flex itemscenter">
                                   <div class="ml-4">
                                      <div
                                         class="textsm font-medium text-gray-900">{{ $post->title }}</div>
                                   </div>
                                </div>
                             </td>
                             <td class="px-6 py-4
                                whitespace-nowrap">
                                <div class="text-sm
                                   text-gray-900">{{ $post->body }}</div>
                             </td>
                             <td class="px-6 py-4
                                whitespace-nowrap">
                                <img src="{{asset('storage/' . $post->image) }}" alt="" class="h-16 w-16">
                             </td>
                             <td class="px-6 py-4
                                whitespace-nowrap text-right text-sm font-medium">
                                <a href="{{ route('post.edit', $post)}}"" class="textindigo-600 hover:text-indigo-900">Edit</a>
                                <form action="{{ route('post.destroy', $post) }}" method="POST">
                                  @csrf
                                  @method('DELETE')
                                  <button class="text-indigo-600 hover:text-indigo-900" 
                                    onclick="return confirm('Are you sure delete this data?')">Delete</button>
                                </form>
                             </td>
                          </tr>
                          @endforeach
                       </tbody>
                    </table>
                 </div>
              </div>
           </div>
        </div>
     </div>
  </div>
</x-app-layout>